import type { Component } from "vue";
import { defineComponent, h } from 'vue'
import TextConfig from './TextConfig.vue'
import ListConfig from './ListConfig.vue'

const configs: Record<string, Component> = {
  text: TextConfig,
  list: ListConfig,
}

function render(type: string, props: Record<string, any>) {
  const component = configs[type]
  if (component) {
    return h(configs[type], props)
  }
  return h('div', `unknown type: ${type}`)
}

export const RenderConfig = defineComponent({
  name: 'DddRenderConfig',

  props: {
    type: String,
    props: Object
  },

  setup(props) {
    return () => render(props.type!, props.props!)
  }
})
